`define ENDPT1_IN
//`define ENDPT2_IN
//`define ENDPT3_IN
//`define ENDPT4_IN
//`define ENDPT5_IN
//`define ENDPT6_IN
//`define ENDPT7_IN
//`define ENDPT8_IN
//`define ENDPT9_IN
//`define ENDPT10_IN
//`define ENDPT11_IN
//`define ENDPT12_IN
//`define ENDPT13_IN
//`define ENDPT14_IN
//`define ENDPT15_IN
//`define ENDPT16_IN

`define ENDPT1_OUT
//`define ENDPT2_OUT
//`define ENDPT3_OUT
//`define ENDPT4_OUT
//`define ENDPT5_OUT
//`define ENDPT6_OUT
//`define ENDPT7_OUT
//`define ENDPT8_OUT
//`define ENDPT9_OUT
//`define ENDPT10_OUT
//`define ENDPT11_OUT
//`define ENDPT12_OUT
//`define ENDPT13_OUT
//`define ENDPT14_OUT
//`define ENDPT15_OUT
//`define ENDPT16_OUT


module usb3_top_device
(
    input           sys_clk,
	input			key_resetn,
    // input           phy_resetn,
    output  [39:0]      tx_data_8b10b_o,
    input   [39:0]      rx_data_8b10b_i,

    output          RxElecIdle1,
    output          led1,
    output          led2
);



reg     [7:0]   cnt0 = 0;
reg     [15:0]  cnt1 = 0;
reg     [15:0]  cnt2 = 0;
reg     [31:0]  cnt3 = 0;
reg     [31:0]  cnt4 = 0;
reg     [7:0]   cnt5 = 0;
reg		[7:0]	key_resetn_r = 8'b11111111;
wire            phy_resetn;
wire            phy_resetn_o = 1 ;
wire            pclk;
reg				led1_r = 1'b0;
reg				led2_r = 1'b0;

wire	[2:0]	RxStatus;
wire			PhyStatus;
wire			phy_pipe_half_clk;        // 125MHz:  1/2 PCLK
wire			phy_pipe_half_clk_phase;  // 125MHz:  1/2 PCLK, phase shift 90
wire			phy_pipe_quarter_clk;     // 62.5MHz: 1/4 PCLK
wire	[31:0]	phy_pipe_rx_data;
wire	[3:0]	phy_pipe_rx_datak;
wire	[1:0]	phy_pipe_rx_valid;
wire			phy_pipe_rx_valid_o;
wire	[31:0]	phy_pipe_tx_data;
wire	[3:0]	phy_pipe_tx_datak;
wire			phy_reset_n;
wire			phy_out_enable;
wire			phy_phy_reset_n;
wire			phy_tx_detrx_lpbk;
wire			phy_tx_elecidle;
wire			phy_rx_elecidle;
wire	[5:0]	phy_rx_status;
wire	[1:0]	phy_power_down;
wire	[1:0]	phy_phy_status_i;
wire	        phy_phy_status_o;
wire			phy_pwrpresent;
wire			phy_tx_oneszeros;
wire	[1:0]	phy_tx_deemph;
wire	[2:0]	phy_tx_margin;
wire			phy_tx_swing;
wire			phy_rx_polarity;
wire			phy_rx_termination;
wire			phy_rate;
wire			phy_elas_buf_mode;
wire	[31:0]	ep0_in_buf_data          ;
wire			ep0_in_buf_wren          ;
wire			ep0_in_buf_ready         ;
wire			ep0_in_buf_data_commit        ;
wire	[10:0]	ep0_in_buf_data_commit_len    ;	
wire	[31:0]	ep0_out_buf_data		 ;
wire	[10:0]	ep0_out_buf_len		     ;
wire			ep0_out_buf_has_data	     ;
wire			ep0_out_buf_data_ack			 ;
wire			ep0_out_buf_rden 		 ;
wire			request_active 	         ;
wire	[7:0]	bmRequestType	         ;
wire	[7:0]	bRequest		         ;
wire	[15:0]	wValue			         ;
wire	[15:0]	wIndex			         ;
wire	[15:0]	wLength		             ;
wire				set_interface 		 ;
wire			   	get_interface 		 ;
wire 	[15:0] 		set_intf_alt_setting ;	
wire 	[15:0] 		set_intf_num	     ;
wire	[15:0]		get_intf_alt_setting ;
wire	[15:0]  	get_intf_num         ;
wire				set_address          ;
wire		[6:0]	dev_address          ;
wire			set_sel                  ;
wire 	[7:0]   set_u1_sel               ;
wire 	[7:0]   set_u1_pel               ;
wire 	[15:0]  set_u2_sel               ;
wire 	[15:0]  set_u2_pel               ;
wire				set_feature          ;
wire				clear_feature        ;
wire		[15:0]	set_feat_sel         ;
wire		[15:0]  set_feat_wIndex      ;
wire		[1:0]  	set_feat_recipient 	 ;
wire		[15:0]	clr_feat_sel         ;
wire		[15:0]	clr_feat_wIndex      ;
wire		[1:0]	clr_feat_recipient	;	
wire				set_config			;
wire		[7:0]	set_config_value    ;
wire				get_config          ;
wire		[7:0] 	get_config_value	;


`ifdef ENDPT1_IN
wire	[31:0]	ep1_in_buf_data             ;
wire			ep1_in_buf_wren             ;
wire			ep1_in_buf_ready            ;
wire			ep1_in_buf_data_commit      ;
wire	[10:0]	ep1_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT1_OUT
wire	[31:0]	ep1_out_buf_data             ;
wire	[10:0]	ep1_out_buf_len              ;
wire			ep1_out_buf_has_data         ;
wire			ep1_out_buf_data_ack         ;
wire			ep1_out_buf_rden			 ;
`endif

`ifdef ENDPT2_IN
wire	[31:0]	ep2_in_buf_data             ;
wire			ep2_in_buf_wren             ;
wire			ep2_in_buf_ready            ;
wire			ep2_in_buf_data_commit      ;
wire	[10:0]	ep2_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT2_OUT
wire	[31:0]	ep2_out_buf_data             ;
wire	[10:0]	ep2_out_buf_len              ;
wire			ep2_out_buf_has_data         ;
wire			ep2_out_buf_data_ack         ;
wire			ep2_out_buf_rden			 ;
`endif

`ifdef ENDPT3_IN
wire	[31:0]	ep3_in_buf_data             ;
wire			ep3_in_buf_wren             ;
wire			ep3_in_buf_ready            ;
wire			ep3_in_buf_data_commit      ;
wire	[10:0]	ep3_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT3_OUT
wire	[31:0]	ep3_out_buf_data             ;
wire	[10:0]	ep3_out_buf_len              ;
wire			ep3_out_buf_has_data         ;
wire			ep3_out_buf_data_ack         ;
wire			ep3_out_buf_rden			 ;
`endif

`ifdef ENDPT4_IN
wire	[31:0]	ep4_in_buf_data             ;
wire			ep4_in_buf_wren             ;
wire			ep4_in_buf_ready            ;
wire			ep4_in_buf_data_commit      ;
wire	[10:0]	ep4_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT4_OUT
wire	[31:0]	ep4_out_buf_data             ;
wire	[10:0]	ep4_out_buf_len              ;
wire			ep4_out_buf_has_data         ;
wire			ep4_out_buf_data_ack         ;
wire			ep4_out_buf_rden			 ;
`endif

`ifdef ENDPT5_IN
wire	[31:0]	ep5_in_buf_data             ;
wire			ep5_in_buf_wren             ;
wire			ep5_in_buf_ready            ;
wire			ep5_in_buf_data_commit      ;
wire	[10:0]	ep5_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT5_OUT
wire	[31:0]	ep5_out_buf_data             ;
wire	[10:0]	ep5_out_buf_len              ;
wire			ep5_out_buf_has_data         ;
wire			ep5_out_buf_data_ack         ;
wire			ep5_out_buf_rden			 ;
`endif

`ifdef ENDPT6_IN
wire	[31:0]	ep6_in_buf_data             ;
wire			ep6_in_buf_wren             ;
wire			ep6_in_buf_ready            ;
wire			ep6_in_buf_data_commit      ;
wire	[10:0]	ep6_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT6_OUT
wire	[31:0]	ep6_out_buf_data             ;
wire	[10:0]	ep6_out_buf_len              ;
wire			ep6_out_buf_has_data         ;
wire			ep6_out_buf_data_ack         ;
wire			ep6_out_buf_rden			 ;
`endif

`ifdef ENDPT7_IN
wire	[31:0]	ep7_in_buf_data             ;
wire			ep7_in_buf_wren             ;
wire			ep7_in_buf_ready            ;
wire			ep7_in_buf_data_commit      ;
wire	[10:0]	ep7_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT7_OUT
wire	[31:0]	ep7_out_buf_data             ;
wire	[10:0]	ep7_out_buf_len              ;
wire			ep7_out_buf_has_data         ;
wire			ep7_out_buf_data_ack         ;
wire			ep7_out_buf_rden			 ;
`endif

`ifdef ENDPT8_IN
wire	[31:0]	ep8_in_buf_data             ;
wire			ep8_in_buf_wren             ;
wire			ep8_in_buf_ready            ;
wire			ep8_in_buf_data_commit      ;
wire	[10:0]	ep8_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT8_OUT
wire	[31:0]	ep8_out_buf_data             ;
wire	[10:0]	ep8_out_buf_len              ;
wire			ep8_out_buf_has_data         ;
wire			ep8_out_buf_data_ack         ;
wire			ep8_out_buf_rden			 ;
`endif

`ifdef ENDPT9_IN
wire	[31:0]	ep9_in_buf_data             ;
wire			ep9_in_buf_wren             ;
wire			ep9_in_buf_ready            ;
wire			ep9_in_buf_data_commit      ;
wire	[10:0]	ep9_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT9_OUT
wire	[31:0]	ep9_out_buf_data             ;
wire	[10:0]	ep9_out_buf_len              ;
wire			ep9_out_buf_has_data         ;
wire			ep9_out_buf_data_ack         ;
wire			ep9_out_buf_rden			 ;
`endif

`ifdef ENDPT10_IN
wire	[31:0]	ep10_in_buf_data             ;
wire			ep10_in_buf_wren             ;
wire			ep10_in_buf_ready            ;
wire			ep10_in_buf_data_commit      ;
wire	[10:0]	ep10_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT10_OUT
wire	[31:0]	ep10_out_buf_data             ;
wire	[10:0]	ep10_out_buf_len              ;
wire			ep10_out_buf_has_data         ;
wire			ep10_out_buf_data_ack         ;
wire			ep10_out_buf_rden			  ;
`endif

`ifdef ENDPT11_IN
wire	[31:0]	ep11_in_buf_data             ;
wire			ep11_in_buf_wren             ;
wire			ep11_in_buf_ready            ;
wire			ep11_in_buf_data_commit      ;
wire	[10:0]	ep11_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT11_OUT
wire	[31:0]	ep11_out_buf_data             ;
wire	[10:0]	ep11_out_buf_len              ;
wire			ep11_out_buf_has_data         ;
wire			ep11_out_buf_data_ack         ;
wire			ep11_out_buf_rden			 ;
`endif

`ifdef ENDPT12_IN
wire	[31:0]	ep12_in_buf_data             ;
wire			ep12_in_buf_wren             ;
wire			ep12_in_buf_ready            ;
wire			ep12_in_buf_data_commit      ;
wire	[10:0]	ep12_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT12_OUT
wire	[31:0]	ep12_out_buf_data             ;
wire	[10:0]	ep12_out_buf_len              ;
wire			ep12_out_buf_has_data         ;
wire			ep12_out_buf_data_ack         ;
wire			ep12_out_buf_rden			  ;
`endif

`ifdef ENDPT13_IN
wire	[31:0]	ep13_in_buf_data             ;
wire			ep13_in_buf_wren             ;
wire			ep13_in_buf_ready            ;
wire			ep13_in_buf_data_commit      ;
wire	[10:0]	ep13_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT13_OUT
wire	[31:0]	ep13_out_buf_data             ;
wire	[10:0]	ep13_out_buf_len              ;
wire			ep13_out_buf_has_data         ;
wire			ep13_out_buf_data_ack         ;
wire			ep13_out_buf_rden			  ;
`endif

`ifdef ENDPT14_IN
wire	[31:0]	ep14_in_buf_data             ;
wire			ep14_in_buf_wren             ;
wire			ep14_in_buf_ready            ;
wire			ep14_in_buf_data_commit      ;
wire	[10:0]	ep14_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT14_OUT
wire	[31:0]	ep14_out_buf_data             ;
wire	[10:0]	ep14_out_buf_len              ;
wire			ep14_out_buf_has_data         ;
wire			ep14_out_buf_data_ack         ;
wire			ep14_out_buf_rden			  ;
`endif

`ifdef ENDPT15_IN
wire	[31:0]	ep15_in_buf_data             ;
wire			ep15_in_buf_wren             ;
wire			ep15_in_buf_ready            ;
wire			ep15_in_buf_data_commit      ;
wire	[10:0]	ep15_in_buf_data_commit_len  ;
`endif 


`ifdef ENDPT15_OUT
wire	[31:0]	ep15_out_buf_data             ;
wire	[10:0]	ep15_out_buf_len              ;
wire			ep15_out_buf_has_data         ;
wire			ep15_out_buf_data_ack         ;
wire			ep15_out_buf_rden			  ;
`endif

assign led1 = led1_r;
assign led2 = led2_r;
assign phy_resetn = cnt0 > 127? 1'b1 : 1'b0;

always@(posedge sys_clk)
begin
	key_resetn_r <= {key_resetn_r[6:0], key_resetn};
end

always@(posedge sys_clk or negedge key_resetn_r[7])
begin
	if(!key_resetn_r[7])
	begin
		cnt3	<= 0;
		led1_r	<= 0;
	end
	else
	begin
		if(cnt3 < 50000000)
		begin
			cnt3	<= cnt3 + 1'b1;
		end
		else
		begin
			cnt3	<= 32'd0;
			led1_r	<= ~led1_r;
		end
	end
end

always@(posedge pclk)
begin
	if(cnt4 < 125000000)
	begin
		cnt4	<= cnt4 + 1'b1;
	end
	else
	begin
		cnt4	<= 32'd0;
		led2_r	<= ~led2_r;
	end
end

always@(posedge sys_clk)
begin
    if(cnt0 < 255)
    begin
        cnt0                <= cnt0 + 1'b1;
    end
    else
    begin
        cnt0                <= cnt0;
    end
end

//usb3_0_phy_top Inst_usb3_0_phy_top(
//	// .ref_clk                (sys_clk),//input			    
//	.phy_resetn             (phy_resetn_o & phy_resetn),//input			    
//	.sys_clk				(sys_clk),
//	.pclk                   (pclk),//output			    
//	.PipeTxData             (phy_pipe_tx_data),//input       [31:0]  
//    .PipeTxDataK            (phy_pipe_tx_datak),//input       [3:0]   
//    .PipeRxData             (phy_pipe_rx_data),//output      [31:0]  
//    .PipeRxDataK            (phy_pipe_rx_datak),//output      [3:0]   
//    .PipeRxDataValid        (phy_pipe_rx_valid_o),//output              
//    .TxDetectRx_loopback    (phy_tx_detrx_lpbk),//input               
//    .TxElecIdle             (phy_tx_elecidle),//input               
//    // .TxDeemph               (2'b0),//input   [1:0]       
//    // .TxMargin               (3'b0),//input   [2:0]       
//    // .TxSwing                (1'b0),//input               
//    .RxPolarity             (phy_rx_polarity),//input               
//    .RxEqTraining           (1'b0),//input               
//    .RxTermination          (phy_rx_termination),//input               
//    .RxElecIdle             (phy_rx_elecidle),//output              
//    .RxStatus               (RxStatus),//output  [2:0]       
//    .ElasticityBufferMode   (phy_elas_buf_mode),//input               
//    .TxOnesZeros            (phy_tx_oneszeros),//input               
//    .PowerDown              (phy_power_down),//input   [1:0]       
//    // .Rate                   (1'b0),//input               
//    .PhyStatus              (PhyStatus),//output              
//    .PowerPresent           (phy_pwrpresent),//output              
//	.tx_data_8b10b_o		(tx_data_8b10b_o),
//	.rx_data_8b10b_i		(rx_data_8b10b_i)
//);

SerDes_Top SerDes_Top_inst(
	.sys_clk_i ( sys_clk ),
    .USB3_0_PHY_Top_pclk(pclk), //output USB3_0_PHY_Top_pclk
    .USB3_0_PHY_Top_PipeRxData(phy_pipe_rx_data), //output [31:0] USB3_0_PHY_Top_PipeRxData
    .USB3_0_PHY_Top_PipeRxDataK(phy_pipe_rx_datak), //output [3:0] USB3_0_PHY_Top_PipeRxDataK
    .USB3_0_PHY_Top_PipeRxDataValid(phy_pipe_rx_valid_o), //output USB3_0_PHY_Top_PipeRxDataValid
    .USB3_0_PHY_Top_RxElecIdle(phy_rx_elecidle), //output USB3_0_PHY_Top_RxElecIdle
    .USB3_0_PHY_Top_RxStatus(RxStatus), //output [2:0] USB3_0_PHY_Top_RxStatus
    .USB3_0_PHY_Top_PhyStatus(PhyStatus), //output USB3_0_PHY_Top_PhyStatus
    .USB3_0_PHY_Top_PowerPresent(phy_pwrpresent), //output USB3_0_PHY_Top_PowerPresent
    .USB3_0_PHY_Top_phy_resetn(phy_resetn_o), //input USB3_0_PHY_Top_phy_resetn
    .USB3_0_PHY_Top_PipeTxData(phy_pipe_tx_data), //input [31:0] USB3_0_PHY_Top_PipeTxData
    .USB3_0_PHY_Top_PipeTxDataK(phy_pipe_tx_datak), //input [3:0] USB3_0_PHY_Top_PipeTxDataK
    .USB3_0_PHY_Top_TxDetectRx_loopback(phy_tx_detrx_lpbk), //input USB3_0_PHY_Top_TxDetectRx_loopback
    .USB3_0_PHY_Top_TxElecIdle(phy_tx_elecidle), //input USB3_0_PHY_Top_TxElecIdle
    .USB3_0_PHY_Top_RxPolarity(phy_rx_polarity), //input USB3_0_PHY_Top_RxPolarity
    .USB3_0_PHY_Top_RxEqTraining(1'b0), //input USB3_0_PHY_Top_RxEqTraining
    .USB3_0_PHY_Top_RxTermination(phy_rx_termination), //input USB3_0_PHY_Top_RxTermination
    .USB3_0_PHY_Top_TxOnesZeros(phy_tx_oneszeros), //input USB3_0_PHY_Top_TxOnesZeros
    .USB3_0_PHY_Top_PowerDown(phy_power_down), //input [1:0] USB3_0_PHY_Top_PowerDown
    .USB3_0_PHY_Top_ElasticityBufferMode(phy_elas_buf_mode), //input USB3_0_PHY_Top_ElasticityBufferMode     
	.tx_data_8b10b_o		(tx_data_8b10b_o),
	.rx_data_8b10b_i		(rx_data_8b10b_i)
);

assign phy_rx_status =  RxStatus;
assign phy_phy_status =  PhyStatus;
assign phy_pipe_rx_valid = phy_pipe_rx_valid_o;

USB30_Device_Controller_Top USB30_Device_Controller_Top_inst (
	.phy_clk_i						(pclk)//input	wire			
	,.reset_n_i						(phy_resetn )//input	wire			
	,.phy_pipe_rx_data_i			(phy_pipe_rx_data)//input	wire	[31:0]	
	,.phy_pipe_rx_datak_i			(phy_pipe_rx_datak)//input	wire	[3:0]	
	,.phy_pipe_rx_valid_i			(phy_pipe_rx_valid)//input	wire	[1:0]	
	,.phy_pipe_tx_data_o			(phy_pipe_tx_data)//output	wire	[31:0]	
	,.phy_pipe_tx_datak_o			(phy_pipe_tx_datak)//output	wire	[3:0]	
	,.phy_reset_n_o					(phy_resetn_o)//output	wire								
	,.phy_tx_detrx_lpbk_o			(phy_tx_detrx_lpbk)//output	wire			
	,.phy_tx_elecidle_o				(phy_tx_elecidle	)//output	wire			
	,.phy_rx_elecidle_i				(phy_rx_elecidle	)//inout	wire			
	,.phy_rx_status_i				(phy_rx_status		)//input	wire	[5:0]	
	,.phy_power_down_o				(phy_power_down		)//output	wire	[1:0]	
	,.phy_phy_status_i				(phy_phy_status		)//input   wire	[1:0]		        
	,.phy_pwrpresent_i				(phy_pwrpresent		)//input	wire			
	,.phy_tx_oneszeros_o			(phy_tx_oneszeros	)//output	wire			
	,.phy_tx_deemph_o				(phy_tx_deemph		)//output	wire	[1:0]	
	,.phy_tx_margin_o				(phy_tx_margin		)//output	wire	[2:0]	
	,.phy_tx_swing_o				(phy_tx_swing		)//output	wire			
	,.phy_rx_polarity_o				(phy_rx_polarity	)//output	wire			
	,.phy_rx_termination_o			(phy_rx_termination	)//output	wire			
	,.phy_rate_o					(phy_rate			)//output	wire			
	,.phy_elas_buf_mode_o			(phy_elas_buf_mode	)//output	wire	


	// external interface
	
	,.warm_or_hot_reset_o ( warm_or_hot_reset ) 
	
	// requests 
	,.request_active_o 		(request_active	)
	,.bmRequestType_o		(bmRequestType	)
	,.bRequest_o			(bRequest		)
	,.wValue_o				(wValue			)
	,.wIndex_o				(wIndex			)
	,.wLength_o				(wLength		)
		
	// ep0 IN  					
	,.ep0_in_buf_data_i					(ep0_in_buf_data		)
	,.ep0_in_buf_wren_i         		(ep0_in_buf_wren	    )
	,.ep0_in_buf_ready_o        		(ep0_in_buf_ready	    )
	,.ep0_in_buf_data_commit_i 	   		(ep0_in_buf_data_commit	    )
	,.ep0_in_buf_data_commit_len_i   	(ep0_in_buf_data_commit_len	)
	
	`ifdef ENDPT1_IN 
	,.ep1_in_buf_data_i					(ep1_in_buf_data		)
	,.ep1_in_buf_wren_i         		(ep1_in_buf_wren	    )
	,.ep1_in_buf_ready_o        		(ep1_in_buf_ready	    )
	,.ep1_in_buf_data_commit_i 	  	 	(ep1_in_buf_data_commit	    )
	,.ep1_in_buf_data_commit_len_i   	(ep1_in_buf_data_commit_len	)
	`endif	
	
	`ifdef ENDPT2_IN 
	,.ep2_in_buf_data_i					(ep2_in_buf_data		)
	,.ep2_in_buf_wren_i         		(ep2_in_buf_wren	    )
	,.ep2_in_buf_ready_o        		(ep2_in_buf_ready	    )
	,.ep2_in_buf_data_commit_i 	  	 	(ep2_in_buf_data_commit	    )
	,.ep2_in_buf_data_commit_len_i   	(ep2_in_buf_data_commit_len	)
	`endif	
	
	`ifdef ENDPT3_IN 
	,.ep3_in_buf_data_i					(ep3_in_buf_data		)
	,.ep3_in_buf_wren_i         		(ep3_in_buf_wren	    )
	,.ep3_in_buf_ready_o        		(ep3_in_buf_ready	    )
	,.ep3_in_buf_data_commit_i 	   		(ep3_in_buf_data_commit	    )
	,.ep3_in_buf_data_commit_len_i		(ep3_in_buf_data_commit_len	)
	`endif	
	
	`ifdef ENDPT4_IN 
	,.ep4_in_buf_data_i					(ep4_in_buf_data		)
	,.ep4_in_buf_wren_i         		(ep4_in_buf_wren	    )
	,.ep4_in_buf_ready_o        		(ep4_in_buf_ready	    )
	,.ep4_in_buf_data_commit_i 	  	 	(ep4_in_buf_data_commit	    )
	,.ep4_in_buf_data_commit_len_i		(ep4_in_buf_data_commit_len	)
	`endif
	
	`ifdef ENDPT5_IN 
	,.ep5_in_buf_data_i					(ep5_in_buf_data		)
	,.ep5_in_buf_wren_i         		(ep5_in_buf_wren	    )
	,.ep5_in_buf_ready_o        		(ep5_in_buf_ready	    )
	,.ep5_in_buf_data_commit_i 	   		(ep5_in_buf_data_commit	    )
	,.ep5_in_buf_data_commit_len_i		(ep5_in_buf_data_commit_len	)
	`endif	
	
	`ifdef ENDPT6_IN 
	,.ep6_in_buf_data_i					(ep6_in_buf_data		)
	,.ep6_in_buf_wren_i         		(ep6_in_buf_wren	    )
	,.ep6_in_buf_ready_o        		(ep6_in_buf_ready	    )
	,.ep6_in_buf_data_commit_i 	  	 	(ep6_in_buf_data_commit	    )
	,.ep6_in_buf_data_commit_len_i		(ep6_in_buf_data_commit_len	)
	`endif	
	
	`ifdef ENDPT7_IN 
	,.ep7_in_buf_data_i					(ep7_in_buf_data		)
	,.ep7_in_buf_wren_i         		(ep7_in_buf_wren	    )
	,.ep7_in_buf_ready_o        		(ep7_in_buf_ready	    )
	,.ep7_in_buf_data_commit_i 	   		(ep7_in_buf_data_commit	    )
	,.ep7_in_buf_data_commit_len_i		(ep7_in_buf_data_commit_len	)
	`endif	
	
	`ifdef ENDPT8_IN 
	,.ep8_in_buf_data_i					(ep8_in_buf_data		)
	,.ep8_in_buf_wren_i         		(ep8_in_buf_wren	    )
	,.ep8_in_buf_ready_o        		(ep8_in_buf_ready	    )
	,.ep8_in_buf_data_commit_i 	   		(ep8_in_buf_data_commit	    )
	,.ep8_in_buf_data_commit_len_i		(ep8_in_buf_data_commit_len	)
	`endif	
	
	`ifdef ENDPT9_IN 
	,.ep9_in_buf_data_i					(ep9_in_buf_data		)
	,.ep9_in_buf_wren_i         		(ep9_in_buf_wren	    )
	,.ep9_in_buf_ready_o        		(ep9_in_buf_ready	    )
	,.ep9_in_buf_data_commit_i 	   		(ep9_in_buf_data_commit	    )
	,.ep9_in_buf_data_commit_len_i		(ep9_in_buf_data_commit_len	)
	`endif	
	
	
	
	`ifdef ENDPT10_IN 
	,.ep10_in_buf_data_i				(ep10_in_buf_data		)
	,.ep10_in_buf_wren_i        		(ep10_in_buf_wren	    )
	,.ep10_in_buf_ready_o       		(ep10_in_buf_ready	    )
	,.ep10_in_buf_data_commit_i 	  	(ep10_in_buf_data_commit	    )
	,.ep10_in_buf_data_commit_len_i		(ep10_in_buf_data_commit_len	)
	`endif	
	
	`ifdef ENDPT11_IN 
	,.ep11_in_buf_data_i				(ep11_in_buf_data		)
	,.ep11_in_buf_wren_i        		(ep11_in_buf_wren	    )
	,.ep11_in_buf_ready_o       		(ep11_in_buf_ready	    )
	,.ep11_in_buf_data_commit_i 	  	(ep11_in_buf_data_commit	    )
	,.ep11_in_buf_data_commit_len_i		(ep11_in_buf_data_commit_len	)
	`endif		
	
	`ifdef ENDPT12_IN 
	,.ep12_in_buf_data_i				(ep12_in_buf_data		)
	,.ep12_in_buf_wren_i        		(ep12_in_buf_wren	    )
	,.ep12_in_buf_ready_o         		(ep12_in_buf_ready	    )
	,.ep12_in_buf_data_commit_i 	  	(ep12_in_buf_data_commit	    )
	,.ep12_in_buf_data_commit_len_i		(ep12_in_buf_data_commit_len	)
	`endif		
	
	`ifdef ENDPT13_IN 
	,.ep13_in_buf_data_i				(ep13_in_buf_data		)
	,.ep13_in_buf_wren_i        		(ep13_in_buf_wren	    )
	,.ep13_in_buf_ready_o       		(ep13_in_buf_ready	    )
	,.ep13_in_buf_data_commit_i 	  	(ep13_in_buf_data_commit	    )
	,.ep13_in_buf_data_commit_len_i		(ep13_in_buf_data_commit_len	)
	`endif		
	
	`ifdef ENDPT14_IN 
	,.ep14_in_buf_data_i				(ep14_in_buf_data		)
	,.ep14_in_buf_wren_i        		(ep14_in_buf_wren	    )
	,.ep14_in_buf_ready_o         		(ep14_in_buf_ready	    )
	,.ep14_in_buf_data_commit_i 	  	(ep14_in_buf_data_commit	    )
	,.ep14_in_buf_data_commit_len_i		(ep14_in_buf_data_commit_len	)
	`endif		
	
	`ifdef ENDPT15_IN 
	,.ep15_in_buf_data_i				(ep15_in_buf_data		)
	,.ep15_in_buf_wren_i        		(ep15_in_buf_wren	    )
	,.ep15_in_buf_ready_o       		(ep15_in_buf_ready	    )
	,.ep15_in_buf_data_commit_i 	  	(ep15_in_buf_data_commit	    )
	,.ep15_in_buf_data_commit_len_i		(ep15_in_buf_data_commit_len	)
	`endif		
	
	
	// ep0 OUT	
	,.ep0_out_buf_data_o		 (ep0_out_buf_data		)	
	,.ep0_out_buf_len_o		     (ep0_out_buf_len		)
	,.ep0_out_buf_has_data_o	 (ep0_out_buf_has_data	)
	,.ep0_out_buf_data_ack_i     (ep0_out_buf_data_ack	)
	,.ep0_out_buf_rden_i         (ep0_out_buf_rden		)
	
	
	`ifdef ENDPT1_OUT
	,.ep1_out_buf_data_o			(ep1_out_buf_data		)
	,.ep1_out_buf_len_o             (ep1_out_buf_len		)
	,.ep1_out_buf_has_data_o        (ep1_out_buf_has_data	)
	,.ep1_out_buf_data_ack_i        (ep1_out_buf_data_ack	)
	,.ep1_out_buf_rden_i            (ep1_out_buf_rden		)
	`endif
	
	
	`ifdef ENDPT2_OUT
	,.ep2_out_buf_data_o			(ep2_out_buf_data		)	 	
	,.ep2_out_buf_len_o			    (ep2_out_buf_len		)
	,.ep2_out_buf_has_data_o	        (ep2_out_buf_has_data	)
	,.ep2_out_buf_data_ack_i        (ep2_out_buf_data_ack	)
	,.ep2_out_buf_rden_i            (ep2_out_buf_rden		)
	`endif	
	
	
	`ifdef ENDPT3_OUT
	,.ep3_out_buf_data_o			(ep3_out_buf_data		)	 	
	,.ep3_out_buf_len_o		        (ep3_out_buf_len		)
	,.ep3_out_buf_has_data_o	        (ep3_out_buf_has_data	)
	,.ep3_out_buf_data_ack_i        (ep3_out_buf_data_ack	)
	,.ep3_out_buf_rden_i            (ep3_out_buf_rden		)
	`endif
	
	
	
	`ifdef ENDPT4_OUT
	,.ep4_out_buf_data_o			(ep4_out_buf_data		) 	
	,.ep4_out_buf_len_o	            (ep4_out_buf_len		)
	,.ep4_out_buf_has_data_o         (ep4_out_buf_has_data	)
	,.ep4_out_buf_data_ack_i        (ep4_out_buf_data_ack	)
	,.ep4_out_buf_rden_i            (ep4_out_buf_rden		)
	`endif	
	
	
	`ifdef ENDPT5_OUT
	,.ep5_out_buf_data_o			(ep5_out_buf_data		)	 	
	,.ep5_out_buf_len_o	            (ep5_out_buf_len		)
	,.ep5_out_buf_has_data_o         (ep5_out_buf_has_data	)
	,.ep5_out_buf_data_ack_i 	    (ep5_out_buf_data_ack	)
	,.ep5_out_buf_rden_i            (ep5_out_buf_rden		)
	`endif	
		
	
	`ifdef ENDPT6_OUT
	,.ep6_out_buf_data_o		 	(ep6_out_buf_data		)	
	,.ep6_out_buf_len_o	            (ep6_out_buf_len		)
	,.ep6_out_buf_has_data_o         (ep6_out_buf_has_data	)
	,.ep6_out_buf_data_ack_i        (ep6_out_buf_data_ack	)
	,.ep6_out_buf_rden_i            (ep6_out_buf_rden		)
	`endif		
		
	
	`ifdef ENDPT7_OUT
	,.ep7_out_buf_data_o			(ep7_out_buf_data		)	 	
	,.ep7_out_buf_len_o	            (ep7_out_buf_len		)
	,.ep7_out_buf_has_data_o         (ep7_out_buf_has_data	)
	,.ep7_out_buf_data_ack_i 	    (ep7_out_buf_data_ack	)
	,.ep7_out_buf_rden_i            (ep7_out_buf_rden		)
	`endif		
	
	
	
	
	`ifdef ENDPT8_OUT
	,.ep8_out_buf_data_o		 	(ep8_out_buf_data		)	
	,.ep8_out_buf_len_o	            (ep8_out_buf_len		)
	,.ep8_out_buf_has_data_o         (ep8_out_buf_has_data	)
	,.ep8_out_buf_data_ack_i 	    (ep8_out_buf_data_ack	)
	,.ep8_out_buf_rden_i            (ep8_out_buf_rden		)
	`endif	
	
	
	
	`ifdef ENDPT9_OUT
	,.ep9_out_buf_data_o		 	(ep9_out_buf_data		)	
	,.ep9_out_buf_len_o	            (ep9_out_buf_len		)
	,.ep9_out_buf_has_data_o         (ep9_out_buf_has_data	)
	,.ep9_out_buf_data_ack_i        (ep9_out_buf_data_ack	)
	,.ep9_out_buf_rden_i            (ep9_out_buf_rden		)
	`endif
	
	
	
	`ifdef ENDPT10_OUT
	,.ep10_out_buf_data_o		 	(ep10_out_buf_data		)	
	,.ep10_out_buf_len_o		    (ep10_out_buf_len		)
	,.ep10_out_buf_has_data_o	    (ep10_out_buf_has_data	)
	,.ep10_out_buf_data_ack_i 	    (ep10_out_buf_data_ack	)
	,.ep10_out_buf_rden_i           (ep10_out_buf_rden		)
	`endif		
	
	
	`ifdef ENDPT11_OUT
	,.ep11_out_buf_data_o			(ep11_out_buf_data		) 	
	,.ep11_out_buf_len_o		    (ep11_out_buf_len		)
	,.ep11_out_buf_has_data_o	    (ep11_out_buf_has_data	)
	,.ep11_out_buf_data_ack_i 	    (ep11_out_buf_data_ack	)
	,.ep11_out_buf_rden_i           (ep11_out_buf_rden		)
	`endif		
	
	`ifdef ENDPT12_OUT
	,.ep12_out_buf_data_o		 	(ep12_out_buf_data		)	
	,.ep12_out_buf_len_o		    (ep12_out_buf_len		)
	,.ep12_out_buf_has_data_o	    (ep12_out_buf_has_data	)
	,.ep12_out_buf_data_ack_i 	    (ep12_out_buf_data_ack	)
	,.ep12_out_buf_rden_i           (ep12_out_buf_rden		)
	`endif		
	
	
	`ifdef ENDPT13_OUT
	,.ep13_out_buf_data_o		 	(ep13_out_buf_data		)	
	,.ep13_out_buf_len_o		    (ep13_out_buf_len		)
	,.ep13_out_buf_has_data_o	    (ep13_out_buf_has_data	)
	,.ep13_out_buf_data_ack_i 	    (ep13_out_buf_data_ack	)
	,.ep13_out_buf_rden_i           (ep13_out_buf_rden		)
	`endif		
	
	
	`ifdef ENDPT14_OUT
	,.ep14_out_buf_data_o		 	(ep14_out_buf_data		)	
	,.ep14_out_buf_len_o		    (ep14_out_buf_len		)
	,.ep14_out_buf_has_data_o	    (ep14_out_buf_has_data	)
	,.ep14_out_buf_data_ack_i 	    (ep14_out_buf_data_ack	)
	,.ep14_out_buf_rden_i           (ep14_out_buf_rden		)
	`endif		
	
	`ifdef ENDPT15_OUT
	,.ep15_out_buf_data_o		 	(ep15_out_buf_data		)
	,.ep15_out_buf_len_o		    (ep15_out_buf_len		)
	,.ep15_out_buf_has_data_o	    (ep15_out_buf_has_data	)
	,.ep15_out_buf_data_ack_i 	    (ep15_out_buf_data_ack	)
	,.ep15_out_buf_rden_i           (ep15_out_buf_rden		)
	`endif	
	
);




UserLayer_top UserLayer_top_inst
(

	.pclk 			(pclk 	   )
	,.phy_resetn    (sys_rst_n & !warm_or_hot_reset )


	// requests
	,.request_active 		(request_active	)
	,.bmRequestType	        (bmRequestType	)
	,.bRequest		        (bRequest		)
	,.wValue			    (wValue			)
	,.wIndex			    (wIndex			)
	,.wLength		        (wLength		)


	// ep0 IN  
	,.ep0_in_buf_data           (ep0_in_buf_data       )
	,.ep0_in_buf_wren           (ep0_in_buf_wren       )
	,.ep0_in_buf_ready          (ep0_in_buf_ready      )
	,.ep0_in_buf_data_commit         (ep0_in_buf_data_commit     )
	,.ep0_in_buf_data_commit_len     (ep0_in_buf_data_commit_len )

	// ep0 OUT
	,.ep0_out_buf_data		 	(ep0_out_buf_data		)
	,.ep0_out_buf_len		    (ep0_out_buf_len		)
	,.ep0_out_buf_has_data	    (ep0_out_buf_has_data	)
	,.ep0_out_buf_data_ack		(ep0_out_buf_data_ack	)
	,.ep0_out_buf_rden			(ep0_out_buf_rden		)

	
	`ifdef ENDPT1_IN 
	,.ep1_in_buf_data              (ep1_in_buf_data              )
	,.ep1_in_buf_wren              (ep1_in_buf_wren              )
	,.ep1_in_buf_ready             (ep1_in_buf_ready             )
	,.ep1_in_buf_data_commit       (ep1_in_buf_data_commit       )
	,.ep1_in_buf_data_commit_len   (ep1_in_buf_data_commit_len   )
	`endif

	`ifdef ENDPT1_OUT
	,.ep1_out_buf_data              (ep1_out_buf_data      )
	,.ep1_out_buf_len               (ep1_out_buf_len       )
	,.ep1_out_buf_has_data          (ep1_out_buf_has_data  )
	,.ep1_out_buf_rden				(ep1_out_buf_rden	   )
	,.ep1_out_buf_data_ack          (ep1_out_buf_data_ack  )
	`endif

	`ifdef ENDPT2_IN 
	,.ep2_in_buf_data				(ep2_in_buf_data			)
	,.ep2_in_buf_wren               (ep2_in_buf_wren           )
	,.ep2_in_buf_ready              (ep2_in_buf_ready          )
	,.ep2_in_buf_data_commit        (ep2_in_buf_data_commit    )
	,.ep2_in_buf_data_commit_len    (ep2_in_buf_data_commit_len)
	`endif	
	
	`ifdef ENDPT2_OUT
	,.ep2_out_buf_data		 (ep2_out_buf_data		)
	,.ep2_out_buf_len        (ep2_out_buf_len       )
	,.ep2_out_buf_has_data   (ep2_out_buf_has_data  )
	,.ep2_out_buf_rden       (ep2_out_buf_rden      )
	,.ep2_out_buf_data_ack   (ep2_out_buf_data_ack  )
	`endif	
	
	`ifdef ENDPT3_IN 
	,.ep3_in_buf_data				(ep3_in_buf_data			)
	,.ep3_in_buf_wren               (ep3_in_buf_wren           )
	,.ep3_in_buf_ready              (ep3_in_buf_ready          )
	,.ep3_in_buf_data_commit        (ep3_in_buf_data_commit    )
	,.ep3_in_buf_data_commit_len    (ep3_in_buf_data_commit_len)
	`endif	
	
	`ifdef ENDPT3_OUT
	,.ep3_out_buf_data			(ep3_out_buf_data		)
	,.ep3_out_buf_len           (ep3_out_buf_len       )
	,.ep3_out_buf_has_data      (ep3_out_buf_has_data  )
	,.ep3_out_buf_rden          (ep3_out_buf_rden      )
	,.ep3_out_buf_data_ack      (ep3_out_buf_data_ack  )
	`endif

	`ifdef ENDPT4_IN 	
	,.ep4_in_buf_data					(ep4_in_buf_data			)	
	,.ep4_in_buf_wren                   (ep4_in_buf_wren            )
	,.ep4_in_buf_ready                  (ep4_in_buf_ready           )
	,.ep4_in_buf_data_commit            (ep4_in_buf_data_commit     )
	,.ep4_in_buf_data_commit_len        (ep4_in_buf_data_commit_len )
	`endif	
	
	`ifdef ENDPT4_OUT
	,.ep4_out_buf_data					(ep4_out_buf_data	   )
	,.ep4_out_buf_len                   (ep4_out_buf_len       )
	,.ep4_out_buf_has_data              (ep4_out_buf_has_data  )
	,.ep4_out_buf_rden                  (ep4_out_buf_rden      )
	,.ep4_out_buf_data_ack              (ep4_out_buf_data_ack  )
	`endif	

	`ifdef ENDPT5_IN 
	,.ep5_in_buf_data					(ep5_in_buf_data			)
	,.ep5_in_buf_wren                   (ep5_in_buf_wren           )
	,.ep5_in_buf_ready                  (ep5_in_buf_ready          )
	,.ep5_in_buf_data_commit            (ep5_in_buf_data_commit    )
	,.ep5_in_buf_data_commit_len        (ep5_in_buf_data_commit_len)
	`endif	
	
	`ifdef ENDPT5_OUT			
	,.ep5_out_buf_data					(ep5_out_buf_data	   )	
	,.ep5_out_buf_len                   (ep5_out_buf_len       )
	,.ep5_out_buf_has_data              (ep5_out_buf_has_data  )
	,.ep5_out_buf_rden                  (ep5_out_buf_rden      )
	,.ep5_out_buf_data_ack              (ep5_out_buf_data_ack  )
	`endif	

	`ifdef ENDPT6_IN 
	,.ep6_in_buf_data					 (ep6_in_buf_data			)
	,.ep6_in_buf_wren                    (ep6_in_buf_wren           )
	,.ep6_in_buf_ready                   (ep6_in_buf_ready          )
	,.ep6_in_buf_data_commit             (ep6_in_buf_data_commit    )
	,.ep6_in_buf_data_commit_len         (ep6_in_buf_data_commit_len)
	`endif	
	
	`ifdef ENDPT6_OUT
	,.ep6_out_buf_data					 (ep6_out_buf_data		)
	,.ep6_out_buf_len                    (ep6_out_buf_len     )
	,.ep6_out_buf_has_data               (ep6_out_buf_has_data)
	,.ep6_out_buf_rden                   (ep6_out_buf_rden    )
	,.ep6_out_buf_data_ack               (ep6_out_buf_data_ack)
	`endif		
	
	`ifdef ENDPT7_IN 
	,.ep7_in_buf_data					 (ep7_in_buf_data			)
	,.ep7_in_buf_wren                    (ep7_in_buf_wren           )
	,.ep7_in_buf_ready                   (ep7_in_buf_ready          )
	,.ep7_in_buf_data_commit             (ep7_in_buf_data_commit    )
	,.ep7_in_buf_data_commit_len         (ep7_in_buf_data_commit_len)
	`endif	
	
	`ifdef ENDPT7_OUT
	,.ep7_out_buf_data					  (ep7_out_buf_data)
	,.ep7_out_buf_len                     (ep7_out_buf_len)
	,.ep7_out_buf_has_data                (ep7_out_buf_has_data)
	,.ep7_out_buf_rden                    (ep7_out_buf_rden)
	,.ep7_out_buf_data_ack                (ep7_out_buf_data_ack)
	`endif		
	
	`ifdef ENDPT8_IN 
	,.ep8_in_buf_data						(ep8_in_buf_data)
	,.ep8_in_buf_wren                       (ep8_in_buf_wren)
	,.ep8_in_buf_ready                      (ep8_in_buf_ready)
	,.ep8_in_buf_data_commit                (ep8_in_buf_data_commit)
	,.ep8_in_buf_data_commit_len            (ep8_in_buf_data_commit_len)
	`endif	
	
	`ifdef ENDPT8_OUT
	,.ep8_out_buf_data						(ep8_out_buf_data)					
	,.ep8_out_buf_len                       (ep8_out_buf_len)
	,.ep8_out_buf_has_data                  (ep8_out_buf_has_data)
	,.ep8_out_buf_rden                      (ep8_out_buf_rden)
	,.ep8_out_buf_data_ack                  (ep8_out_buf_data_ack)
	`endif	
	
	`ifdef ENDPT9_IN 
	,.ep9_in_buf_data						(ep9_in_buf_data)
	,.ep9_in_buf_wren                       (ep9_in_buf_wren)
	,.ep9_in_buf_ready                      (ep9_in_buf_ready)
	,.ep9_in_buf_data_commit                (ep9_in_buf_data_commit)
	,.ep9_in_buf_data_commit_len            (ep9_in_buf_data_commit_len)
	`endif	
	
	`ifdef ENDPT9_OUT
	,.ep9_out_buf_data						(ep9_out_buf_data)			
	,.ep9_out_buf_len                       (ep9_out_buf_len)
	,.ep9_out_buf_has_data                  (ep9_out_buf_has_data)
	,.ep9_out_buf_rden                      (ep9_out_buf_rden)
	,.ep9_out_buf_data_ack                  (ep9_out_buf_data_ack)
	`endif
	
	`ifdef ENDPT10_IN 
	,.ep10_in_buf_data						(ep10_in_buf_data			)
	,.ep10_in_buf_wren                      (ep10_in_buf_wren           )
	,.ep10_in_buf_ready                     (ep10_in_buf_ready          )
	,.ep10_in_buf_data_commit               (ep10_in_buf_data_commit    )
	,.ep10_in_buf_data_commit_len           (ep10_in_buf_data_commit_len)
	`endif	
	
	`ifdef ENDPT10_OUT
	,.ep10_out_buf_data						(ep10_out_buf_data		)
	,.ep10_out_buf_len                      (ep10_out_buf_len      )
	,.ep10_out_buf_has_data                 (ep10_out_buf_has_data )
	,.ep10_out_buf_rden                     (ep10_out_buf_rden     )
	,.ep10_out_buf_data_ack                 (ep10_out_buf_data_ack )
	`endif		

	`ifdef ENDPT11_IN 
	,.ep11_in_buf_data						(ep11_in_buf_data			)
	,.ep11_in_buf_wren                      (ep11_in_buf_wren           )
	,.ep11_in_buf_ready                     (ep11_in_buf_ready          )
	,.ep11_in_buf_data_commit               (ep11_in_buf_data_commit    )
	,.ep11_in_buf_data_commit_len           (ep11_in_buf_data_commit_len)
	`endif	
	
	`ifdef ENDPT11_OUT
	,.ep11_out_buf_data						(ep11_out_buf_data		)
	,.ep11_out_buf_len                      (ep11_out_buf_len      )
	,.ep11_out_buf_has_data                 (ep11_out_buf_has_data )
	,.ep11_out_buf_rden                     (ep11_out_buf_rden     )
	,.ep11_out_buf_data_ack                 (ep11_out_buf_data_ack )
	`endif		

	`ifdef ENDPT12_IN 
	,.ep12_in_buf_data						(ep12_in_buf_data			)
	,.ep12_in_buf_wren                      (ep12_in_buf_wren           )
	,.ep12_in_buf_ready                     (ep12_in_buf_ready          )
	,.ep12_in_buf_data_commit               (ep12_in_buf_data_commit    )
	,.ep12_in_buf_data_commit_len           (ep12_in_buf_data_commit_len)
	`endif	
	
	`ifdef ENDPT12_OUT
	,.ep12_out_buf_data						(ep12_out_buf_data)
	,.ep12_out_buf_len                      (ep12_out_buf_len)
	,.ep12_out_buf_has_data                 (ep12_out_buf_has_data)
	,.ep12_out_buf_rden                     (ep12_out_buf_rden)
	,.ep12_out_buf_data_ack                 (ep12_out_buf_data_ack)
	`endif		
	
	`ifdef ENDPT13_IN 
	,.ep13_in_buf_data						(ep13_in_buf_data			)
	,.ep13_in_buf_wren                      (ep13_in_buf_wren           )
	,.ep13_in_buf_ready                     (ep13_in_buf_ready          )
	,.ep13_in_buf_data_commit               (ep13_in_buf_data_commit    )
	,.ep13_in_buf_data_commit_len           (ep13_in_buf_data_commit_len)
	`endif	
	
	`ifdef ENDPT13_OUT
	,.ep13_out_buf_data						(ep13_out_buf_data		)
	,.ep13_out_buf_len                      (ep13_out_buf_len      )
	,.ep13_out_buf_has_data                 (ep13_out_buf_has_data )
	,.ep13_out_buf_rden                     (ep13_out_buf_rden     )
	,.ep13_out_buf_data_ack                 (ep13_out_buf_data_ack )
	`endif		
	
	`ifdef ENDPT14_IN 
	,.ep14_in_buf_data						(ep14_in_buf_data			)
	,.ep14_in_buf_wren                      (ep14_in_buf_wren           )
	,.ep14_in_buf_ready                     (ep14_in_buf_ready          )
	,.ep14_in_buf_data_commit               (ep14_in_buf_data_commit    )
	,.ep14_in_buf_data_commit_len           (ep14_in_buf_data_commit_len)
	`endif	
	
	`ifdef ENDPT14_OUT
	,.ep14_out_buf_data						(ep14_out_buf_data		)
	,.ep14_out_buf_len                      (ep14_out_buf_len      )
	,.ep14_out_buf_has_data                 (ep14_out_buf_has_data )
	,.ep14_out_buf_rden                     (ep14_out_buf_rden     )
	,.ep14_out_buf_data_ack                 (ep14_out_buf_data_ack )
	`endif		
	
	
	`ifdef ENDPT15_IN 
	,.ep15_in_buf_data						(ep15_in_buf_data			)
	,.ep15_in_buf_wren                      (ep15_in_buf_wren           )
	,.ep15_in_buf_ready                     (ep15_in_buf_ready          )
	,.ep15_in_buf_data_commit               (ep15_in_buf_data_commit    )
	,.ep15_in_buf_data_commit_len           (ep15_in_buf_data_commit_len)
	`endif	
	
	`ifdef ENDPT15_OUT
	,.ep15_out_buf_data						(ep15_out_buf_data		   )
	,.ep15_out_buf_len                      (ep15_out_buf_len          )
	,.ep15_out_buf_has_data                 (ep15_out_buf_has_data     )
	,.ep15_out_buf_rden                     (ep15_out_buf_rden         )
	,.ep15_out_buf_data_ack                 (ep15_out_buf_data_ack     )
	`endif			
);



endmodule
