`timescale 1ns/10ps
module usb_3_0_sim_top
(

);

reg                 sys_clk;
wire    [39:0]      tx_data_8b10b;
wire    [39:0]      rx_data_8b10b;

always 
begin
	sys_clk = 0 ; #4 ;
	sys_clk = 1 ; #4 ;
end




usb3_top_host usb3_top_host
(
    .sys_clk             (sys_clk),//input               
	.key_resetn          (1'b1),//input			    
    .tx_data_8b10b_o     (tx_data_8b10b),//output  [39:0]      
    .rx_data_8b10b_i     (rx_data_8b10b),//input   [39:0]      
    .RxElecIdle1         (),//output              
    .led1                (),//output              
    .led2                ()//output              
);

usb3_top_device usb3_top_device
(
    .sys_clk             (sys_clk),//input               
	.key_resetn          (1'b1),//input			    
    .tx_data_8b10b_o     (rx_data_8b10b),//output  [39:0]      
    .rx_data_8b10b_i     (tx_data_8b10b),//input   [39:0]      
    .RxElecIdle1         (),//output              
    .led1                (),//output              
    .led2                ()//output              
);

endmodule